using System;
using System.Configuration;
using System.Web.UI;
using FooTheory.CodeCamp.DI.DataAccess;
using FooTheory.CodeCamp.DI.Interfaces.DataAccess;
using FooTheory.CodeCamp.DI.Interfaces.DTO;
using FooTheory.CodeCamp.DI.Interfaces.Services;
using FooTheory.CodeCamp.DI.Interfaces.Services.Mappers;
using FooTheory.CodeCamp.DI.Services;
using FooTheory.CodeCamp.DI.Services.Mappers;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;

namespace FooTheory.CodeCamp.DI.WebApp
{
    public partial class _Default : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            #region Manual Configuration

            IUnityContainer container = new UnityContainer()
            .RegisterType<ICustomerRepository, CustomerRepository>()
            .RegisterType<ICustomerDTOMapper, CustomerDTOMapper>()
            .RegisterType<ICustomerService, CustomerService>();


            #endregion


            #region DI through Configuration

            //
            // Fire up  the container. 
            //
            //IUnityContainer container = new UnityContainer();
            //UnityConfigurationSection section = (UnityConfigurationSection)ConfigurationManager.GetSection("unity");
            //section.Containers.Default.Configure(container);

            #endregion

            ICustomerService service = container.Resolve<ICustomerService>();
            CustomerDTO dto = service.GetACustomerFrom(5);

            Response.Write(String.Format("Customer Name is: {0}.", dto.Name));
            Break();
            Response.Write(String.Format("Customer Age is: {0}.", dto.Age));
            Break();
            Response.Write(String.Format("Customer Id is: {0}", dto.Id));
        }

        private void Break()
        {
            Response.Write("<br>");
        }
    }
}